#ifndef SENSOR_H_


#define SENSOR_H_



#include "onewire.h"



#define MAXSENSORS		7

//#define SENSORDATA_LEN	48

#define TEMP_BEGIN		OW_ROMCODE_SIZE		//	8 -> 0 - 7
#define TEMP_LEN			6							// 6 +12,3 = 5 + 0  8,9,10,11,12,13
#define BUS_BEGIN			(OW_ROMCODE_SIZE+TEMP_LEN)
#define BUS_LEN			2							// 
#define NULL_BEGIN		(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN)
#define NULL_LEN			4
#define MINUS_BEGIN		(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN)
#define MINUS_LEN			4
#define PLUS_BEGIN		(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN)
#define PLUS_LEN			4
#define MINLEN_BEGIN		(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN)
#define MINLEN_LEN		4
#define MINCOLBL_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN)
#define MINCOLBL_LEN		2
#define MINCOLRT_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN)
#define MINCOLRT_LEN		2
#define MAXLEN_BEGIN		(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN)
#define MAXLEN_LEN		4
#define MAXCOLBL_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN+MAXLEN_LEN)
#define MAXCOLBL_LEN		2
#define MAXCOLRT_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN+MAXLEN_LEN+MAXCOLBL_LEN)
#define MAXCOLRT_LEN		2
#define MINTEMP_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN+MAXLEN_LEN+MAXCOLBL_LEN+MAXCOLRT_LEN)
#define MINTEMP_LEN		6
#define MAXTEMP_BEGIN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN+MAXLEN_LEN+MAXCOLBL_LEN+MAXCOLRT_LEN+MINTEMP_LEN)
#define MAXTEMP_LEN		6


#define SENSORDATA_LEN	(OW_ROMCODE_SIZE+TEMP_LEN+BUS_LEN+NULL_LEN+MINUS_LEN+PLUS_LEN+MINLEN_LEN+MINCOLBL_LEN+MINCOLRT_LEN+MAXLEN_LEN+MAXCOLBL_LEN+MAXCOLRT_LEN+MINTEMP_LEN+MAXTEMP_LEN+1)



extern uint8_t diff, nSensors;


extern uint8_t gSensorIDs[MAXSENSORS][OW_ROMCODE_SIZE];


extern char sensor_id_str[MAXSENSORS][SENSORDATA_LEN];



void clr_all_sensors(void);
void show_all_sensors(void);

void read_all_sensors(void);
void ein_sensor_lesen_komma_einsetzen(uint8_t, uint8_t *, uint8_t );
//jar_debug
//char *ein_sensor_lesen_komma_einsetzen(uint8_t, uint8_t *, uint8_t );
uint8_t search_sensors(uint8_t);

void read_found_single_sensor(uint8_t, unsigned long);
void eeprom_test(void);




/*

 after search 4 Sensor(s) available

282e075503000057 +19,2C, Wohnzimmer,    Bus:#3, NULL:136, MINUS:4, PLUS:76

284dc793030000df +14,7C, Schlafzimmer,  Bus:#4, NULL:136, MINUS:4, PLUS:56

2893d4930300003a +16,9C, kl. Zimmer,    Bus:#1, NULL:136, MINUS:4, PLUS:64

288bd19303000012 +22,3C, Zhlerschrank, Bus:#1, NULL:136, MINUS:4, PLUS:88




 after search 4 Sensor(s) available

282e075503000057 +19,1C, Wohnzimmer,    Bus:#3, NULL:136, MINUS:4, PLUS:76

284dc793030000df +14,9C, Schlafzimmer,  Bus:#3, NULL:136, MINUS:4, PLUS:56

2893d4930300003a +16,9C, kl. Zimmer,    Bus:#1, NULL:136, MINUS:4, PLUS:64

288bd19303000012 +22,4C, Zhlerschrank, Bus:#1, NULL:136, MINUS:4, PLUS:88

*/



#endif // #ifndef SENSOR_H_


